import re,xbmcplugin,xbmcgui,urllib2
import xbmc
import xbmcaddon
import os
import urlparse
from urllib2 import URLError
from urllib import quote, unquote_plus, unquote, urlencode,quote_plus,urlretrieve

pluginhandle=int(sys.argv[1])
addon=xbmcaddon.Addon(id='plugin.video.SimpleSouthpark')
home=addon.getAddonInfo('path').decode('utf-8')
icon=xbmc.translatePath(os.path.join(home, 'icon.png'))
fanart=xbmc.translatePath(os.path.join(home, 'fanart.jpg'))
imageDir=os.path.join(home, 'thumbnails') + '/'
view_mode_id=int('503')
xbmcplugin.setContent(pluginhandle, 'Episodes')
mrss='http://www.southpark.de/feeds/video-player/mrss/mgid:arc:episode:southpark.de:%s'
lang="&lang=de"

def staffeln():
	url='http://www.southpark.de/alle-episoden'
	html=geturl(url)
	for url,name in re.findall('<a class="seasonbtn.*?" href="(.*?)">(.*?)</a>',html,re.S):
		name='Staffel  %s' % name
		addDir(name,url,'episoden',icon)
	xbmcplugin.endOfDirectory(pluginhandle)
		
def episoden(url):
	html=geturl(url)
	spl=html.split('<a class="content_eppreview"')
	for i in range(1,len(spl),1):
		entry=spl[i]
		try:
			url=re.findall('<a href="(.*?)">Diese Episode ansehen</a>',entry,re.S)[0]
			temp=re.findall('s\d+e\d+',url)[0]
			temp=temp.split('e')
			season=temp[0].replace('s','')
			episode=temp[1]
		except:
			url='#'
		iconimage=re.findall('<img src="(.*?)\?',entry,re.S)[0]
		name=re.findall('<h5>(.*?)</h5>',entry,re.S)[0]
		splDate=re.findall('<h6>Erstausstrahlung: (.*?)</h6>',entry,re.S)[0].split(".")
		date=splDate[2]+"-"+splDate[1]+"-"+splDate[0]
		desc=re.findall('<p>(.*?)</p>',entry,re.S)[0]
		addLink(name,url,'getvideo_url',iconimage,desc,season,episode,date)
	xbmcplugin.endOfDirectory(pluginhandle)
	xbmc.executebuiltin('Container.SetViewMode(%d)' % view_mode_id)
		
def getvideo_url(iconimage,url):
	playlist=xbmc.PlayList( xbmc.PLAYLIST_VIDEO )
	playlist.clear()
	if url=='#':
		xbmc.executebuiltin("XBMC.Notification('Video nicht vorhanden',2000)")
	else:
		html=geturl(url)
		video_id=re.findall('spsi-de-DE/episodes/(.*?)"\stype="text/javascript"></script>',html,re.S)[0]
		url=mrss % video_id
		print url
		html=geturl(url)
		xmls=re.findall('<item>.*?<title>(.*?)</title>.*?<media:category\sscheme="urn:mtvn:id">mgid:arc:video:southparkstudios.com:(.*?)</media:category>', html, re.S)
		for title, id in xmls:
			if not re.match(".*?Intro\sHD", title):
				try:
					video_xml = "http://www.southpark.de/feeds/video-player/mediagen?uri=mgid:arc:episode:southpark.de:%s&suppressRegisterBeacon=true&suppressRegisterBeacon=true&acceptMethods=rtmp%s" % (id, lang)
				except:
					video_xml = "http://www.southpark.de/feeds/video-player/mediagen?uri=mgid:arc:episode:southpark.de:%s&suppressRegisterBeacon=true&suppressRegisterBeacon=true&acceptMethods=mp4%s" % (id, lang)
				else:
					video_xml = "http://www.southpark.de/feeds/video-player/mediagen?uri=mgid:arc:episode:southpark.de:%s&suppressRegisterBeacon=true&suppressRegisterBeacon=true&acceptMethods=flv%s" % (id, lang)	
				html=geturl(video_xml)
				video_url=re.findall('type=".*?" bitrate=".*?">.*?<src>(.*?)</src>',html,re.S)[0]	
				f=urllib2.urlopen(video_url)
				if f.headers['Content-Type'] == 'video/mp4':
					print 'working Video'
					xlistitem=xbmcgui.ListItem(title, iconImage="DefaultFolder.png", thumbnailImage=iconimage)
					xlistitem.setInfo( "video", { "Title": title } )
					video_url=str(video_url)
					playlist.add(video_url,xlistitem)
				else:
					xbmc.executebuiltin("XBMC.Notification('Kein Stream ansprechbar',2000)")
		xbmc.Player().play( playlist)
	

def geturl(url):
	req=urllib2.Request(url, None, {'User-Agent': 'Mozilla/5.0'})
	response=urllib2.urlopen(req)
	link=response.read()
	response.close()
	return link
	
def addDir(name,url,mode,iconimage):
    u=sys.argv[0]+"?url="+quote_plus(url)+"&mode="+str(mode)+"&name="+quote_plus(name)
    ok=True
    item=xbmcgui.ListItem(name, iconImage="DefaultFolder.png", thumbnailImage=iconimage)
    item.setInfo( type="Video", infoLabels={ "Title": name } )
    item.setProperty('fanart_image', fanart)
    xbmcplugin.addDirectoryItem(pluginhandle,url=u,listitem=item,isFolder=True)
    
def addLink(name,url,mode,iconimage,desc,season,episode,date):
    u=sys.argv[0]+"?url="+quote_plus(url)+"&mode="+str(mode)+"&iconimage="+str(iconimage)
    ok=True
    item=xbmcgui.ListItem(name, iconImage="DefaultVideo.png", thumbnailImage=iconimage)
    item.setInfo(type="Video", infoLabels={"Title": name, "Plot": desc, "Season": season, "Episode": episode, "Aired": date})
    item.setProperty('fanart_image', fanart)
    xbmcplugin.addDirectoryItem(pluginhandle,url=u,listitem=item)

def parameters_string_to_dict(parameters):
    ''' Convert parameters encoded in a URL to a dict. '''
    paramDict={}
    if parameters:
        paramPairs=parameters[1:].split("&")
        for paramsPair in paramPairs:
            paramSplits=paramsPair.split('=')
            if (len(paramSplits)) == 2:
                paramDict[paramSplits[0]] = paramSplits[1]
    return paramDict

params=parameters_string_to_dict(sys.argv[2])
mode=params.get('mode')
url=params.get('url')
iconimage=params.get('iconimage')
if type(url)==type(str()):
  url=unquote_plus(url)
 

if mode=='episoden':
	episoden(url)
elif mode=='getvideo_url':
	getvideo_url(iconimage,url)
else:
   staffeln()
